#include <iostream>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);

    long N;
    cin >> N;

    long A[N], B[N];

    for (long i=0; i<N; i++)
    {
        cin >> A[i];
    }
    for (long i=0; i<N; i++)
    {
        cin >> B[i];
    }

    long maks = 0;
    for (long L=0; L<N; L++)
    {
        long xors = A[L];
        long ands = B[L];
        for (long R=L+1; R<N; R++)
        {
            xors = xors ^ A[R];
            ands = ands && B[R];

            if (ands == 0)
            {
                break;
            }
        }

        long vrednost = xors*ands;
        if (maks < vrednost)
        {
            maks = vrednost;
        }
    }
    cout << maks;
    return 0;
}